<?php
/**
 * Created by JetBrains PhpStorm.
 * User: alessandrobartel
 * Date: 02/07/12
 * Time: 11:51
 * To change this template use File | Settings | File Templates.
 */
 
class RegistroDescontoHomolognet extends RegistroHomolognet {

    const OUTROS = 'Outros';
    const OUTRO = 'Outro';
    const DESCONTO = 'Desconto';

    const VALOR_ADIANTAMENTO_SALARIAL ='VLAdiantamentoSalarial';
    const VALOR_COMPENSACAO_DIAS_SALARIO_FERIAS_MES_AFASTAMENTO = 'VLCompensacaoDiasSalarioFeriasMesAfastamento';
    const VALOR_ADIANTAMENTO_13_SALARIO = 'VLAdiantamento13Salario';
    const NUMERO_FALTAS = 'NRFaltas';
    const VALOR_VALE_TRANSPORTE = 'VLValeTransporte';
    const VALOR_VALE_ALIMENTACAO = 'VLValeAlimentacao';
    const VALOR_REEMBOLSO_VALE_TRANSPORTE = 'VLReembolsoVT';
    const VALOR_REEMBOLSO_VALE_ALIMENTACAO = 'VLReembolsoVA';
    const VALOR_CREDITO_CONSIGNADO= 'VLCreditoConsignado';
    const VALOR_INDENIZACAO = 'VLIndenizacao';
    const VALOR_CONTRIBUICAO_PREVIDENCIA_PRIVADA = 'VLContribuicaoPrevidenciaPrivada';
    const VALOR_CONSTRIBUICAO_FAPI = 'VLContribuicaoFapi';
    const VALOR_OUTRAS_DEDUCOES_BASE_IRRF = 'VLOutrasDeducoesBaseCalculoIRRF';
    const VALOR_COMPLEMENTO_IRRF_RENDIMENTO_MES_QUITACAO = 'VLComplementacaoIRRFRendimentoMesQuitacao';
    const VALOR_CONTRIBUICAO_SINDICAL_LABORAL = 'VLContribuicaoSindicalLaboral';
    const CODIGO_OUTRO = 'CDOutro';
    const VALOR_DESCONTO = 'VLDesconto';
    const CODIGO_INCIDENTE_TRIBUTACAO = 'CDIncidenteTributacao';

    const TP_CONTRATO_DETERMINADO = '3';

    private $_codDesconto = 1;

    private $_outrosDescontos;
    private $_desconto;


    public function setCodDesconto($codDesconto){
        $this->_codDesconto = $codDesconto;
    }

    public function getCodDesconto(){
        return $this->_codDesconto;
    }

    public function incrementaCodDesconto(){
        $this->_codDesconto++;
    }

    public function setOutrosDescontos($outrosDescontos = null) {
        $this->_outrosDescontos = $outrosDescontos;
    }

    public function setDesconto($desconto){
        $this->_desconto = $desconto;
    }

    public function concatenaOutrosDescontos() {
        $this->_outrosDescontos .= $this->getLinhaRegistro();
    }


    public function geraOutrosDescontos($outrosDescontos){

        $tag = self::OUTRO;
        $this->atribuiDadoXML($tag, parent::CARACTER_SEPARADOR, null, 0);
        
        // Campo 85 - Tamanho 03 - Codigos de outros descontos
        $this->_atribuiCodigoOutro($outrosDescontos->codigo);

        // Campo 86 - Tamanho 14 - Valor de Outros Descontos informado no campo 85.
        $this->_atribuiValorDesconto($outrosDescontos->valor);

        // Campo 87 - Tamanho 03 - Indicador de incidência de tributação sobre o desconto
        $this->_atribuiCodigoIncidenteTributacao($outrosDescontos->tributacao);

        $tag = parent::CARACTER_FINALIZADOR;
        $this->atribuiDadoXML($tag, parent::CARACTER_SEPARADOR, null, 0);
    }


    public function geraRegistroDesconto($outrosDescontos){

        $this->_geraRegistro($outrosDescontos);
    }

    private function _geraRegistro($outrosDescontos){

        // Campo 77 - Tamanho 14 - Adiantamento Salarial
        $this->_atribuiValorAdiantamentoSalarial();

//        // Campo 77.1 - Tamanho 14 - Compensação Dias de Salário Férias ref. Mês do Afastamento pago no Mês Anterior à Rescisão.
//        $this->_atribuiValorCompensacaoDiasFeriasMesAfastamento();

        // Campo 78 - Tamanho 14 - Adiantamento 13º Salário
        $this->_atribuiValorAdiantamento13Salario();

        // Campo 79 - Tamanho 02 - Faltas Injustificadas do mês da rescisão acrescidos do DSR correspondente.
        $this->_atribuiNumeroFaltas();

        // Campo 80 - Tamanho 14 - Valor Total Gasto com Vale-Transporte
        $this->_atribuiValorValeTransporte();

        // Campo 81 - Tamanho 14 - Desconto do Vale-Alimentação
        $this->_atribuiValorValeAlimentacao();

//        // Campo 82 - Tamanho 14 - Reembolso de vale transporte
//        $this->_atribuiValorReembolsoValeTransporte();
//
//        // Campo 83 - Tamanho 14 - Reembolso de vale alimentação
//        $this->_atribuiValorReembolsoValeAlimentacao();

        // Campo 84 - Tamanho 14 - Saldo Devedor Atual do Empréstimo consignado em folha de pagamento
        $this->_atribuiValorCreditoConsignado();

        // Campo 88 - Tamanho 14 - Indenização Art. 480 CLT - CAMPO NÃO OBRIGATÓRIO
        $this->_atribuiValorIndenizacao();

        // Campo 89 - Tamanho 14 - Contribuições para as entidades de previdência privada domiciliadas no Brasil.
        $this->_atribuiValorPrevidenciaPrivada();

        // Campo 90 - Tamanho 14 - Contribuições para o FAPI.
        $this->_atribuiValorFAPI();

        // Campo 92 - Tamanho 14 - Contribuição sindical laboral, art. 580 CLT.
        $this->_atribuiValorContribuicaoSindicalLaboral();

        // Campo 91 - Tamanho 14 - Outras Deduções para base de cálculo IRRF
        $this->_atribuiValorDeducoesBaseIRRF();

        // Campo 91.1 - Tamanho 14 - Complementação do IRRF, ref. Rendimento Total recebido no Mês de Quitação da Rescisão.
        $this->_atribuiComplementoIRRFMesQuitacao();


        if (empty($outrosDescontos) === false) {
            $tag = self::OUTROS;
            $this->atribuiDadoXML($tag, parent::CARACTER_SEPARADOR, null, 0);

            // Codigos de outros descontos
            $this->geraOutrosDescontos($outrosDescontos);

            $tag = parent::CARACTER_FINALIZADOR;
            $this->atribuiDadoXML($tag, parent::CARACTER_SEPARADOR, null, 0);
        }
    }


    private function _atribuiValorAdiantamentoSalarial(){

        $dado = $this->_desconto->adiantamentoSalarial;
        if (empty($dado) === true) {
            $dado = '0.00';
        }
        $tag = self::VALOR_ADIANTAMENTO_SALARIAL.parent::CARACTER_ATRIBUI;
        $this->atribuiDadoXML($tag, parent::CARACTER_SEPARADOR, $dado, 14, true);
    }

//    private function _atribuiValorCompensacaoDiasFeriasMesAfastamento(){
//
//        $dado = $this->_desconto->compensacaoDias;
//        if (empty($dado) === true) {
//            $dado = '0.00';
//        }
//        $tag = self::VALOR_COMPENSACAO_DIAS_SALARIO_FERIAS_MES_AFASTAMENTO.parent::CARACTER_ATRIBUI;
//        $this->atribuiDadoXML($tag, parent::CARACTER_SEPARADOR, $dado, 14, true);
//    }

    private function _atribuiValorAdiantamento13Salario(){

        $dado = $this->_desconto->adiantamento13Salarial;
        if (empty($dado) === true) {
            $dado = '0.00';
        }
        $tag = self::VALOR_ADIANTAMENTO_13_SALARIO.parent::CARACTER_ATRIBUI;
        $this->atribuiDadoXML($tag, parent::CARACTER_SEPARADOR, $dado, 14, true);
    }

    private function _atribuiNumeroFaltas(){

        $dado = $this->_desconto->faltas;
        if (empty($dado) === true) {
            $dado = '00';
        }
        $dado = str_replace('.','',$dado);
        $tag = self::NUMERO_FALTAS.parent::CARACTER_ATRIBUI;
        $this->atribuiDadoXML($tag, parent::CARACTER_SEPARADOR, $dado, 2, true);
    }

    private function _atribuiValorValeTransporte(){

        $dado = $this->_desconto->valeTransporte;
        if (empty($dado) === true) {
            $dado = '0.00';
        }
        $tag = self::VALOR_VALE_TRANSPORTE.parent::CARACTER_ATRIBUI;
        $this->atribuiDadoXML($tag, parent::CARACTER_SEPARADOR, $dado, 14, true);
    }

    private function _atribuiValorValeAlimentacao(){

        $dado = $this->_desconto->valeAlimentacao;
        if (empty($dado) === true) {
            $dado = '0.00';
        }
        $tag = self::VALOR_VALE_ALIMENTACAO.parent::CARACTER_ATRIBUI;
        $this->atribuiDadoXML($tag, parent::CARACTER_SEPARADOR, $dado, 14, true);
    }

    private function _atribuiValorReembolsoValeTransporte(){

        $dado = $this->_desconto->reembolsoValeTransporte;
        if (empty($dado) === true) {
            $dado = '0.00';
        }
        $tag = self::VALOR_REEMBOLSO_VALE_TRANSPORTE.parent::CARACTER_ATRIBUI;
        $this->atribuiDadoXML($tag, parent::CARACTER_SEPARADOR, $dado, 14, true);
    }

    private function _atribuiValorReembolsoValeAlimentacao(){

        $dado = $this->_desconto->reembolsoValeAlimentacao;
        if (empty($dado) === true) {
            $dado = '0.00';
        }
        $tag = self::VALOR_REEMBOLSO_VALE_ALIMENTACAO.parent::CARACTER_ATRIBUI;
        $this->atribuiDadoXML($tag, parent::CARACTER_SEPARADOR, $dado, 14, true);
    }

    private function _atribuiValorCreditoConsignado(){

        $dado = $this->_desconto->creditoConsignado;
        if (empty($dado) === true) {
            $dado = '0.00';
        }
        $tag = self::VALOR_CREDITO_CONSIGNADO.parent::CARACTER_ATRIBUI;
        $this->atribuiDadoXML($tag, parent::CARACTER_SEPARADOR, $dado, 14, true);
    }

    private function _atribuiValorIndenizacao(){

        $registroContrato = new RegistroContratoHomolognet();
        if ($registroContrato->tpContratoTrabalho === self::TP_CONTRATO_DETERMINADO) {
            $dado = $this->_desconto->indenizacao;
            if (empty($dado) === true) {
                $dado = '0.00';
            }
            $tag = self::VALOR_INDENIZACAO.parent::CARACTER_ATRIBUI;
            $this->atribuiDadoXML($tag, parent::CARACTER_SEPARADOR, $dado, 14, true);
        }
    }

    private function _atribuiValorPrevidenciaPrivada(){

        $dado = $this->_desconto->previdenciaPrivada;
        if (empty($dado) === true) {
            $dado = '0.00';
        }
        $tag = self::VALOR_CONTRIBUICAO_PREVIDENCIA_PRIVADA.parent::CARACTER_ATRIBUI;
        $this->atribuiDadoXML($tag, parent::CARACTER_SEPARADOR, $dado, 14, true);
    }

    private function _atribuiValorFAPI(){

        $dado = $this->_desconto->fapi;
        if (empty($dado) === true) {
            $dado = '0.00';
        }
        $tag = self::VALOR_CONSTRIBUICAO_FAPI.parent::CARACTER_ATRIBUI;
        $this->atribuiDadoXML($tag, parent::CARACTER_SEPARADOR, $dado, 14, true);
    }

    private function _atribuiValorDeducoesBaseIRRF(){

        $dado = $this->_desconto->outrasDeducoesIRRF;
        if (empty($dado) === true) {
            $dado = '0.00';
        }
        $tag = self::VALOR_OUTRAS_DEDUCOES_BASE_IRRF.parent::CARACTER_ATRIBUI;
        $this->atribuiDadoXML($tag, parent::CARACTER_SEPARADOR, $dado, 14, true);
    }

    private function _atribuiComplementoIRRFMesQuitacao(){

        $dado = $this->_desconto->complementacaoIRRF;
        if (empty($dado) === true) {
            $dado = '0.00';
        }
        $tag = self::VALOR_COMPLEMENTO_IRRF_RENDIMENTO_MES_QUITACAO.parent::CARACTER_ATRIBUI;
        $this->atribuiDadoXML($tag, parent::CARACTER_SEPARADOR, $dado, 14, true);
    }
    
    private function _atribuiValorContribuicaoSindicalLaboral(){

        $dado = $this->_desconto->contribuicaoSindicalLaboral;
        if (empty($dado) === true) {
            $dado = '0.00';
        }
        $tag = self::VALOR_CONTRIBUICAO_SINDICAL_LABORAL.parent::CARACTER_ATRIBUI;
        $this->atribuiDadoXML($tag, parent::CARACTER_SEPARADOR, $dado, 14, true);
    }

    private function _atribuiCodigoOutro($codigo){

        $dado = (string)$codigo;
        if (empty($dado) === false) {
            $tag = self::CODIGO_OUTRO.parent::CARACTER_ATRIBUI;
            $this->atribuiDadoXML($tag, parent::CARACTER_SEPARADOR, $dado, 3, true);
        }
    }

    private function _atribuiValorDesconto($valor){

        $dado = $valor;
        if (empty($dado) === false) {
            $tag = self::VALOR_DESCONTO.parent::CARACTER_ATRIBUI;
            $this->atribuiDadoXML($tag, parent::CARACTER_SEPARADOR, $dado, 14, true);
        }
    }

    private function _atribuiCodigoIncidenteTributacao($incidencia){

        $dado = $incidencia;
        if (empty($dado) === false) {
            $tag = self::CODIGO_INCIDENTE_TRIBUTACAO.parent::CARACTER_ATRIBUI;
            $this->atribuiDadoXML($tag, parent::CARACTER_SEPARADOR, $dado, 3, true);
        }
    }



}
