/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_DIETSERV                                                 */
/* Tabela : DIETSERV                                                          */
/*                                                                            */
/* Criao:                                                                   */
/*                                                                            */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_DIETSERV
BEFORE INSERT OR UPDATE OR DELETE
ON DIETSERV FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUDISE := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.CDDIETPAD,0)  <> NVL(:NEW.CDDIETPAD,0))  OR
         (NVL(:OLD.CDSERVFILI,0) <> NVL(:NEW.CDSERVFILI,0)) OR
         (NVL(:OLD.CDFILIAL,0)   <> NVL(:NEW.CDFILIAL,0)) THEN
         :NEW.DTULTATUDISE := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('DIETSERV', :OLD.CDFILIAL, 'CDDIETPAD='||:OLD.CDDIETPAD||';CDFILIAL='||:OLD.CDFILIAL||';CDSERVFILI='||:OLD.CDSERVFILI||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE DIETSERV MODIFY DTULTATUDISE DEFAULT SYSDATE
/
